<?xml version="1.0" encoding="iso-8859-1"?>

<!-- ce script xsl permet d'avoir la FAQ sous forme de fichier html -->
<!-- toute la FAQ est dans un seul fichier -->
<!-- on peut utiliser le paramtre intro pour changer l'introduction utilise -->
<!-- (voir le fichier faq.xml, dans les lments intro) -->
<!-- par dfaut l'introduction utilise est 'standard' -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN" encoding="iso-8859-1"/>
<xsl:param name="intro" select="'standard'"/>

<!-- on vire tous les espaces en trop -->
<xsl:strip-space elements="*"/>
<xsl:template match="text()"><xsl:value-of select="translate(self::text(),&quot;&#x9;&#xa;&#xd;&quot;,&quot;   &quot;)"/></xsl:template>

<!-- template pour crer un numro de question/chapitre -->
<xsl:template name="numero">
<xsl:param name="parenthese" select="'oui'"/>
<xsl:choose>
	<xsl:when test="name()='chapitre'"><xsl:value-of select="count(preceding-sibling::chapitre)+1"/><xsl:if test="$parenthese='oui'">] </xsl:if></xsl:when>
	<xsl:when test="name()='question'"><xsl:value-of select="count(../preceding-sibling::chapitre)+1"/>.<xsl:value-of select="count(preceding-sibling::question)+1"/><xsl:if test="$parenthese='oui'">) </xsl:if></xsl:when>
	<xsl:when test="name()='sousquestion'"><xsl:value-of select="count(../../preceding-sibling::chapitre)+1"/>.<xsl:value-of select="count(../preceding-sibling::question)+1"/>.<xsl:value-of select="count(preceding-sibling::sousquestion)+1"/><xsl:if test="$parenthese='oui'">) </xsl:if></xsl:when>
</xsl:choose>
</xsl:template>

<!-- balise de base du document -->
<xsl:template match="/"><html lang="fr"><head><title>FAQ BeOS</title></head>
<body><h1 align="center">FAQ BeOS</h1>
<p><xsl:apply-templates select="faq/intro[@dest=$intro]"/></p>
<hr/><h1>Sommaire:</h1>
<xsl:for-each select="faq/chapitre">
<br/><a><xsl:attribute name="href">#<xsl:call-template name="numero"><xsl:with-param name="parenthese" select="'non'"/></xsl:call-template></xsl:attribute>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/></a>

	<xsl:for-each select="question">
<br/><a><xsl:attribute name="href">#<xsl:call-template name="numero"><xsl:with-param name="parenthese" select="'non'"/></xsl:call-template></xsl:attribute>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/></a>

		<xsl:for-each select="sousquestion">
<br/><a><xsl:attribute name="href">#<xsl:call-template name="numero"><xsl:with-param name="parenthese" select="'non'"/></xsl:call-template></xsl:attribute>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/></a>

		</xsl:for-each>
	</xsl:for-each>
<br/>
</xsl:for-each>
<hr/>
<xsl:apply-templates select="faq/chapitre"/>
<hr/>
<p><xsl:apply-templates select="faq/conclusion"/></p>
</body></html>
</xsl:template>

<!-- un chapitre -> On met le numro et le nom du chapitre -->
<xsl:template match="chapitre">
<h2><a><xsl:attribute name="name"><xsl:call-template name="numero"><xsl:with-param name="parenthese" select="'non'"/></xsl:call-template></xsl:attribute>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/></a></h2>
<xsl:apply-templates select="question"/>
</xsl:template>

<!-- une question -> On met le numro de la question et son nom -->
<xsl:template match="question">
<h3><a><xsl:attribute name="name"><xsl:call-template name="numero"><xsl:with-param name="parenthese" select="'non'"/></xsl:call-template></xsl:attribute>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/></a></h3>
<xsl:apply-templates select="p|sousquestion"/>
</xsl:template>

<!-- une sous-question -> On met le numro de la sous-question et son nom -->
<xsl:template match="sousquestion">
<h4><a><xsl:attribute name="name"><xsl:call-template name="numero"><xsl:with-param name="parenthese" select="'non'"/></xsl:call-template></xsl:attribute>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/></a></h4>
<xsl:apply-templates select="p"/>
</xsl:template>

<!-- un paragraphe -->
<xsl:template match="p"><p><xsl:apply-templates/></p></xsl:template>

<!-- un lien -->
<xsl:template match="lien"><a href="{@url}"><xsl:apply-templates/></a></xsl:template>

<!-- du gras -->
<xsl:template match="b"><b><xsl:apply-templates/></b></xsl:template>

<!-- une liste -->
<xsl:template match="liste"><xsl:text disable-output-escaping="yes">&lt;/p></xsl:text><ul><xsl:apply-templates/></ul><xsl:text disable-output-escaping="yes">&lt;p></xsl:text></xsl:template>

<!-- un lment de liste -->
<xsl:template match="elem"><li><xsl:apply-templates/></li></xsl:template>

</xsl:stylesheet> 
