<?xml version="1.0" encoding="iso-8859-1"?>

<!-- ce script xsl permet d'avoir la FAQ sous forme de fichier html -->
<!-- il gnre une page chapitre dans le cas d'une FAQ spare par chapitres -->
<!-- utiliser le script faq-html-multi-index.xsl pour gnrer l'index -->
<!-- le nom du fichier de sortie DOIT tre de la forme faq*.html o * est le numro du chapitre, sinon les liens de l'index ne seront pas corrects -->
<!-- il faut spcifier au transformateur XSLT le numro du chapitre  gnrer, en changeant la valeur du paramtre 'chapitre' -->
<!-- le paramtre 'index' doit contenir le nom du fichier html qui contient l'index -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN" encoding="iso-8859-1"/>
<xsl:param name="chapitre" select="0"/>
<xsl:param name="index" select="index.html"/>

<!-- on vire tous les espaces en trop -->
<xsl:strip-space elements="*"/>
<xsl:template match="text()"><xsl:value-of select="translate(self::text(),&quot;&#x9;&#xa;&#xd;&quot;,&quot;   &quot;)"/></xsl:template>

<!-- template pour crer un numro de question/chapitre -->
<xsl:template name="numero">
<xsl:param name="parenthese" select="'oui'"/>
<xsl:choose>
	<xsl:when test="name()='chapitre'"><xsl:value-of select="count(preceding-sibling::chapitre)+1"/><xsl:if test="$parenthese='oui'">] </xsl:if></xsl:when>
	<xsl:when test="name()='question'"><xsl:value-of select="count(../preceding-sibling::chapitre)+1"/>.<xsl:value-of select="count(preceding-sibling::question)+1"/><xsl:if test="$parenthese='oui'">) </xsl:if></xsl:when>
	<xsl:when test="name()='sousquestion'"><xsl:value-of select="count(../../preceding-sibling::chapitre)+1"/>.<xsl:value-of select="count(../preceding-sibling::question)+1"/>.<xsl:value-of select="count(preceding-sibling::sousquestion)+1"/><xsl:if test="$parenthese='oui'">) </xsl:if></xsl:when>
</xsl:choose>
</xsl:template>

<!-- balise de base du document -->
<xsl:template match="/">
<xsl:if test="$chapitre=0"><xsl:message terminate="yes">Il faut spcifier un numro de chapitre,  l'aide du paramtre 'chapitre'</xsl:message></xsl:if>
<xsl:apply-templates select="faq/chapitre[count(preceding-sibling::chapitre)+1=$chapitre]"/>
</xsl:template>

<!-- un chapitre -> On met le numro et le nom du chapitre -->
<xsl:template match="chapitre">
<html lang="fr"><head><title>FAQ BeOS: <xsl:value-of select="@nom"/></title></head>
<body><h1 align="center">FAQ BeOS: <xsl:value-of select="@nom"/></h1>
<hr/><a href="{$index}">Retour  l'index</a><br/>
<xsl:for-each select="question">
<br/><a><xsl:attribute name="href">#<xsl:call-template name="numero"><xsl:with-param name="parenthese" select="'non'"/></xsl:call-template></xsl:attribute>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/></a>

	<xsl:for-each select="sousquestion">
<br/><a><xsl:attribute name="href">#<xsl:call-template name="numero"><xsl:with-param name="parenthese" select="'non'"/></xsl:call-template></xsl:attribute>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/></a>

	</xsl:for-each>
</xsl:for-each>
<hr/>
<xsl:apply-templates select="question"/>
</body></html>
</xsl:template>

<!-- une question -> On met le numro de la question et son nom -->
<xsl:template match="question">
<h3><a><xsl:attribute name="name"><xsl:call-template name="numero"><xsl:with-param name="parenthese" select="'non'"/></xsl:call-template></xsl:attribute>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/></a></h3>
<xsl:apply-templates select="p|sousquestion"/>
</xsl:template>

<!-- une sous-question -> On met le numro de la sous-question et son nom -->
<xsl:template match="sousquestion">
<h4><a><xsl:attribute name="name"><xsl:call-template name="numero"><xsl:with-param name="parenthese" select="'non'"/></xsl:call-template></xsl:attribute>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/></a></h4>
<xsl:apply-templates select="p"/>
</xsl:template>

<!-- un paragraphe -->
<xsl:template match="p"><p><xsl:apply-templates/></p></xsl:template>

<!-- un lien -->
<xsl:template match="lien"><a href="{@url}"><xsl:apply-templates/></a></xsl:template>

<!-- du gras -->
<xsl:template match="b"><b><xsl:apply-templates/></b></xsl:template>

<!-- une liste -->
<xsl:template match="liste"><xsl:text disable-output-escaping="yes">&lt;/p></xsl:text><ul><xsl:apply-templates/></ul><xsl:text disable-output-escaping="yes">&lt;p></xsl:text></xsl:template>

<!-- un lment de liste -->
<xsl:template match="elem"><li><xsl:apply-templates/></li></xsl:template>

</xsl:stylesheet> 
