<?xml version="1.0" encoding="iso-8859-1"?>

<!-- ce script xsl permet d'avoir la FAQ sous forme de fichier texte -->
<!-- on peut utiliser le paramtre intro pour changer l'introduction utilise -->
<!-- (voir le fichier faq.xml, dans les lments intro) -->
<!-- par dfaut l'introduction utilise est 'standard' -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="iso-8859-1"/>
<xsl:param name="intro" select="'standard'"/>

<!-- on vire tous les espaces en trop -->
<xsl:strip-space elements="*"/>
<!--xsl:template match="text()"><xsl:value-of select="normalize-space(self::text())"/></xsl:template-->
<xsl:template match="text()"><xsl:value-of select="translate(self::text(),&quot;&#x9;&#xa;&#xd;&quot;,&quot;   &quot;)"/></xsl:template>

<!-- template pour crer un numro de question/chapitre -->
<xsl:template name="numero">
<xsl:choose>
	<xsl:when test="name()='chapitre'"><xsl:value-of select="count(preceding-sibling::chapitre)+1"/>] </xsl:when>
	<xsl:when test="name()='question'"><xsl:value-of select="count(../preceding-sibling::chapitre)+1"/>.<xsl:value-of select="count(preceding-sibling::question)+1"/>) </xsl:when>
	<xsl:when test="name()='sousquestion'"><xsl:value-of select="count(../../preceding-sibling::chapitre)+1"/>.<xsl:value-of select="count(../preceding-sibling::question)+1"/>.<xsl:value-of select="count(preceding-sibling::sousquestion)+1"/>) </xsl:when>
</xsl:choose>
</xsl:template>

<!-- balise de base du document -->
<xsl:template match="/"><xsl:apply-templates select="faq/intro[@dest=$intro]"/><xsl:text>


Sommaire:
</xsl:text>
<xsl:for-each select="faq/chapitre">
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/><xsl:text>
</xsl:text>
	<xsl:for-each select="question">
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/><xsl:text>
</xsl:text>
		<xsl:for-each select="sousquestion">
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/><xsl:text>
</xsl:text>
		</xsl:for-each>
	</xsl:for-each>
</xsl:for-each>
<xsl:apply-templates select="faq/chapitre"/>
<xsl:text>


</xsl:text>
<xsl:apply-templates select="faq/conclusion"/>
</xsl:template>

<!-- un chapitre -> On met le numro et le nom du chapitre -->
<xsl:template match="chapitre"><xsl:text>


</xsl:text>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/>
<xsl:apply-templates select="question"/>
</xsl:template>

<!-- une question -> On met le numro de la question et son nom -->
<xsl:template match="question"><xsl:text>

</xsl:text><xsl:call-template name="numero"/><xsl:value-of select="@nom"/>
<xsl:apply-templates select="p|sousquestion"/>
</xsl:template>

<!-- une sous-question -> On met le numro de la sous-question et son nom -->
<xsl:template match="sousquestion"><xsl:text>

</xsl:text>
<xsl:call-template name="numero"/><xsl:value-of select="@nom"/>
<xsl:apply-templates select="p"/>
</xsl:template>

<!-- un paragraphe -->
<xsl:template match="p"><xsl:text>
</xsl:text><xsl:apply-templates/></xsl:template>

<!-- un lien -->
<xsl:template match="lien"><xsl:apply-templates/><xsl:if test="not(@pourtexte) or @pourtexte = 'oui'"> &lt;<xsl:value-of select="@url"/>&gt;</xsl:if></xsl:template>

<!-- du gras -->
<xsl:template match="b"><xsl:apply-templates/></xsl:template>

<!-- une liste -->
<xsl:template match="liste"><xsl:text>
</xsl:text><xsl:apply-templates/></xsl:template>

<!-- un lment de liste -->
<xsl:template match="elem"><xsl:text>
</xsl:text>* <xsl:apply-templates/></xsl:template>

</xsl:stylesheet> 
